<template>
    <div class="auth-page">
        <div class="container">
            <div class="row h-100 justify-content-center align-items-center">
                <div class="col-md-6 col-lg-4 form-container rounded">
                    <div class="title text-secondary text-center py-4">LOGIN</div>
                    <form @submit.prevent="onSubmit(email, password)" class="col-12">
                        <div class="form-group my-4">
                            <label htmlFor="email">Email</label>
                            <input type="text" v-model="email" name="email" class="form-control" v-validate="'required'"
                                   :class="{ 'is-invalid': submitted && errors.has('email') }" />
                            <div v-if="submitted && errors.has('email')" class="invalid-feedback">{{ errors.first('email') }}</div>
                        </div>
                        <div class="form-group my-4">
                            <label htmlFor="password">Password</label>
                            <input type="password" v-model="password" name="password" class="form-control" v-validate="'required'"
                                   :class="{ 'is-invalid': submitted && errors.has('password') }" />
                            <div v-if="submitted && errors.has('password')" class="invalid-feedback">{{ errors.first('password') }}</div>
                        </div>
                        <div class="form-group my-4">
                            <button class="btn btn-block btn-primary">Login</button>
                            <div class="pt-3">Don't have account?<router-link :to="{ name: 'register' }"><span class="mx-2 font-weight-bold text-dark text-decoration-none">Register Now</span></router-link>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import {mapState} from "vuex";
    import {LOGIN} from "@/store/actions.type";

    export default {
        name: "Login",
        data() {
            return {
                email: null,
                password: null,
                submitted: false
            };
        },
        methods: {
            onSubmit(email, password) {
                this.submitted = true;
                this.$validator.validate().then(valid => {
                    if (valid) {
                        this.$store
                            .dispatch(LOGIN, {email, password})
                            .then(() => this.$router.push({name: "articles"}));
                    }
                });
            }
        },
        computed: {
            ...mapState({
                errors: state => state.auth.errors
            })
        }
    };
</script>
<style scoped>
    .auth-page {
        height: 100vh;
        display: flex;
        align-items: center;
        justify-content: center;
    }

    .form-container {
        background-color: #ECEEEF;
    }
    .title{
        font-size: 47px;
    }
</style>
